/**
 * Material.cpp
 * Lum, Darrell
 * CPE 471-01
 * Final Project, due 6 June 2006
 * Z. Wood
 * 
 * The Material class is a singleton object that instantiates the materials
 * used in lighting calculations.
 *
 * Original Source: N/A
 * Edits:
 * 1. DAL:  implemented final project.
 **/

#include "include.h"

/**
 * Set up a specific material.
 * materials:  the material to set up.
 */
void Material::materials(Material::materialStruct materials)
{
    glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, materials.ambient);
    glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, materials.diffuse);
    glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, materials.specular);
    glMaterialfv(GL_FRONT_AND_BACK, GL_SHININESS, materials.shininess);
}

/**
 * Initialize the materials.
 */
void Material::init_materials()
{
    GLfloat blue_ambient[] = {0.1, 0.1, 0.5, 1.0};
    GLfloat blue_diffuse[] = {1.0, 1.0, 1.0, 1.0};
    GLfloat blue_specular[] = {0.5, 0.5, 0.5, 1.0};
    GLfloat blue_shininess[] = {1.0};
    blue.init_material(
        blue_ambient,
        blue_diffuse,
        blue_specular,
        blue_ambient
    );

    GLfloat black_ambient[] = {0.0, 0.0, 0.0, 1.0};
    GLfloat black_diffuse[] = {0.0, 0.0, 0.0, 1.0};
    GLfloat black_specular[] = {0.0, 0.0, 0.0, 1.0};
    GLfloat black_shininess[] = {0.0};
    black.init_material(
        black_ambient,
        black_diffuse,
        black_specular,
        black_ambient
    );

    GLfloat flesh_ambient[] = {1.0, 0.957, 0.867, 1.0};
    GLfloat flesh_diffuse[] = {0.5, 0.3, 0.3, 1.0};
    GLfloat flesh_specular[] = {0.5, 0.5, 0.5, 1.0};
    GLfloat flesh_shininess[] = {0.3};
    flesh.init_material(
        flesh_ambient,
        flesh_diffuse,
        flesh_specular,
        flesh_ambient
    );

    GLfloat gold_ambient[] = {0.24725, 0.1995, 0.0745, 1.0};
    GLfloat gold_diffuse[] = {0.75164, 0.60648, 0.22648, 1.0};
    GLfloat gold_specular[] = {0.628281, 0.555802, 0.366065, 1.0};
    GLfloat gold_shininess[] = {0.4};
    gold.init_material(
        gold_ambient,
        gold_diffuse,
        gold_specular,
        gold_ambient
    );

    GLfloat green_ambient[] = {0.0, 1.0, 0.0, 1.0};
    GLfloat green_diffuse[] = {0.75164, 0.60648, 0.22648, 1.0};
    GLfloat green_specular[] = {0.628281, 0.555802, 0.366065, 1.0};
    GLfloat green_shininess[] = {0.4};
    green.init_material(
        green_ambient,
        green_diffuse,
        green_specular,
        green_ambient
    );

    GLfloat jade_ambient[] = {0.135, 0.2225, 0.1575, 1.0};
    GLfloat jade_diffuse[] = {0.54, 0.89, 0.63, 1.0};
    GLfloat jade_specular[] = {0.316228, 0.316228, 0.316228, 1.0};
    GLfloat jade_shininess[] = {0.1};
    jade.init_material(
        jade_ambient,
        jade_diffuse,
        jade_specular,
        jade_ambient
    );

    GLfloat light_blue_ambient[] = {0.6, 0.6, 1.0, 1.0};
    GLfloat light_blue_diffuse[] = {1.0, 1.0, 1.0, 0.6};
    GLfloat light_blue_specular[] = {0.8, 0.8, 0.8, 1.0};
    GLfloat light_blue_shininess[] = {1.0};
    light_blue.init_material(
        light_blue_ambient,
        light_blue_diffuse,
        light_blue_specular,
        light_blue_ambient
    );

    GLfloat pink_ambient[] = {1.00000, 0.733333, 0.793333, 1.0};
    GLfloat pink_diffuse[] = {0.5, 0.5, 0.5, 0.6};
    GLfloat pink_specular[] = {0.3, 0.3, 0.3, 1.0};
    GLfloat pink_shininess[] = {1.0};
    pink.init_material(
        pink_ambient,
        pink_diffuse,
        pink_specular,
        pink_ambient
    );

    // Not correct values
    GLfloat red_ambient[] = {0.135, 0.2225, 0.1575, 1.0};
    GLfloat red_diffuse[] = {0.54, 0.89, 0.63, 1.0};
    GLfloat red_specular[] = {0.316228, 0.316228, 0.316228, 1.0};
    GLfloat red_shininess[] = {0.1};
    red.init_material(
        red_ambient,
        red_diffuse,
        red_specular,
        red_ambient
    );

    GLfloat white_ambient[] = {1.0, 1.0, 1.0, 1.0};
    GLfloat white_diffuse[] = {0.0, 0.0, 0.0, 0.3};
    GLfloat white_specular[] = {0.0, 0.0, 0.0, 1.0};
    GLfloat white_shininess[] = {0.0};
    white.init_material(
        white_ambient,
        white_diffuse,
        white_specular,
        white_ambient
    );

    GLfloat white_solid_ambient[] = {2.0, 2.0, 2.0, 1.0};
    GLfloat white_solid_diffuse[] = {1.0, 1.0, 1.0, 1.0};
    GLfloat white_solid_specular[] = {1.0, 1.0, 1.0, 1.0};
    GLfloat white_solid_shininess[] = {1.0};
    white_solid.init_material(
        white_solid_ambient,
        white_solid_diffuse,
        white_solid_specular,
        white_solid_ambient
    );

    GLfloat yellow_ambient[] = {1.0, 1.0, 0.5, 1.0};
    GLfloat yellow_diffuse[] = {0.8, 0.8, 0.0, 0.5};
    GLfloat yellow_specular[] = {0.6, 0.6, 0.5, 1.0};
    GLfloat yellow_shininess[] = {0.25};
    yellow.init_material(
        yellow_ambient,
        yellow_diffuse,
        yellow_specular,
        yellow_ambient
    );
}