/**
 * Material.h
 * Lum, Darrell
 * CPE 471-01
 * Final Project, due 6 June 2006
 * Z. Wood
 * 
 * The Material class is a singleton object that instantiates the materials
 * used in lighting calculations.
 *
 * Original Source: N/A
 * Edits:
 * 1. DAL:  implemented final project.
 **/

#ifndef MATERIAL_H
#define MATERIAL_H

#include "include.h"

static class Material
{
    /**
     * materialStruct defines the lighting components for materials.
     */
    typedef struct materialStruct
    {
        GLfloat ambient[4];     // Ambient material component
        GLfloat diffuse[4];     // Diffuse material component
        GLfloat specular[4];    // Specular material component
        GLfloat shininess[1];   // Shininess material component
        
        /**
         * Set the singleton to represent a particular material.
         */
        void init_material(GLfloat ambient_in[4], GLfloat diffuse_in[4], 
            GLfloat specular_in[4], GLfloat shininess_in[1])
        {
            for(int i = 0; i < 4; i++)
            {
                ambient[i] = ambient_in[i];
                diffuse[i] = diffuse_in[i];
                specular[i] = specular_in[i];
            }
            shininess[0] = shininess_in[0];
        }
    } materialStruct;

public:
    materialStruct blue;    // Spirit spheres
    materialStruct black;   // Skill name background
    materialStruct flesh;   // Monk flesh (depreciated)
    materialStruct gold;    // Light location (and currently, the fury aura)
    materialStruct green;   // Skill bar/timer
    materialStruct jade;    // Default world floor
    materialStruct light_blue;    // GFist blast wave
    materialStruct pink;    // Poring (depreciated)
    materialStruct red;     // Fury effect overlay on the monk (not featured)
    materialStruct white;   // Aura petals
    materialStruct white_solid;   // Skill name lettering
    materialStruct yellow;  // Spirit sphere and fury casting auras

    void init_materials();
    void materials(materialStruct materials);
} m;

#endif