/**
 * Tri.cpp
 * Lum, Darrell
 * CPE 471-01
 * Final Project, due 6 June 2006
 * Z. Wood
 * 
 * A Triangle is a structure whose shape is determined by three vertices.
 *
 * Original Source: My Program 4 code.
 * Edits:
 * 1. DAL:  implemented final project.
 **/

#include "include.h"

/**
 * Calculate the normal on the face given by t.
 * t:  Triangle for normal calculation.
 * points:  Index of points belonging to triangles.
 * partID:  Index into points to retrieve a certain body part.
 * Postcondition:  t->normal will contain the normal for t's face.
 */
void calcNormal(Tri* t, vector<Point3 *> * points, int partID)
{
    Vector3 w1;
    Vector3 w2;

    w1.x = points[partID][t->v3]->x - points[partID][t->v2]->x;
    w1.y = points[partID][t->v3]->y - points[partID][t->v2]->y;
    w1.z = points[partID][t->v3]->z - points[partID][t->v2]->z;

    w2.x = points[partID][t->v1]->x - points[partID][t->v2]->x;
    w2.y = points[partID][t->v1]->y - points[partID][t->v2]->y;
    w2.z = points[partID][t->v1]->z - points[partID][t->v2]->z;
    crossProd(w1, w2, t->normal);
}