/**
 * Vector3.cpp
 * Lum, Darrell
 * CPE 471-01
 * Final Project, due 6 June 2006
 * Z. Wood
 * 
 * Vector3 is a structure that stores 3D points.
 *
 * Original Source: N/A
 * Edits:
 * 1. DAL:  implemented final project.
 **/

#include "include.h"

/**
 * Computes the dot product of two 3D vectors.
 * v1:  first vector
 * v2:  second vector
 */
float dotProd(Vector3 v1, Vector3 v2)
{
    return v1.x*v2.x + v1.y*v2.y + v1.z*v2.z;
}

/**
 * Computes the angle between two vectors in radians.
 * v1:  first vector
 * v2:  second vector
 */
float getAngle(Vector3 v1, Vector3 v2)
{
    float len1 = sqrt(v1.x*v1.x + v1.y*v1.y + v1.z*v1.z);
    float len2 = sqrt(v2.x*v2.x + v2.y*v2.y + v2.z*v2.z);

    return acos(dotProd(v1, v2)/(len1*len2));
}

/**
 * Computes the cross product of two 3D vectors.
 * a:  first vector
 * b:  second vector
 * c:  resulting cross product of a and b
 * Postcondition:  c will have the cross product of a and b.
 */
void crossProd(Vector3 a, Vector3 b, Vector3 &c)
{
    c.x = a.y*b.z - a.z*b.y;
    c.y = a.z*b.x - a.x*b.z;
    c.z = a.x*b.y - a.y*b.x;
}

/**
 * Computes the length of the given vector.
 * v1:  Vector3 for computation.
 */
float getVectorLength(Vector3 v)
{
    return sqrt(v.x * v.x + v.y * v.y + v.z * v.z);
}
